diff --git a/gcc/analyzer/engine.cc b/gcc/analyzer/engine.cc
index 9d22950d79b..14737295831 100644
--- a/gcc/analyzer/engine.cc
+++ b/gcc/analyzer/engine.cc
@@ -34,6 +34,7 @@ along with GCC; see the file COPYING3.  If not see
 #include "stringpool.h"
 #include "attribs.h"
 #include "tree-dfa.h"
+#include "gimple-predict.h"
 
 #include "text-art/dump.h"
 
@@ -56,6 +57,7 @@ along with GCC; see the file COPYING3.  If not see
 #include "analyzer/call-info.h"
 #include "analyzer/known-function-manager.h"
 #include "analyzer/call-summary.h"
+#include "analyzer/impl-sm-context.h"
 
 /* For an overview, see gcc/doc/analyzer.texi.  */
 
@@ -73,14 +75,12 @@ impl_region_model_context (exploded_graph &eg,
 			   uncertainty_t *uncertainty,
 			   path_context *path_ctxt,
 			   const gimple *stmt,
-			   stmt_finder *stmt_finder,
 			   bool *out_could_have_done_work)
 : m_eg (&eg), m_logger (eg.get_logger ()),
   m_enode_for_diag (enode_for_diag),
   m_old_state (old_state),
   m_new_state (new_state),
   m_stmt (stmt),
-  m_stmt_finder (stmt_finder),
   m_ext_state (eg.get_ext_state ()),
   m_uncertainty (uncertainty),
   m_path_ctxt (path_ctxt),
@@ -97,7 +97,6 @@ impl_region_model_context (program_state *state,
   m_old_state (nullptr),
   m_new_state (state),
   m_stmt (nullptr),
-  m_stmt_finder (nullptr),
   m_ext_state (ext_state),
   m_uncertainty (uncertainty),
   m_path_ctxt (nullptr),
@@ -106,25 +105,14 @@ impl_region_model_context (program_state *state,
 }
 
 bool
-impl_region_model_context::warn (std::unique_ptr<pending_diagnostic> d,
-				 const stmt_finder *custom_finder)
+impl_region_model_context::warn_at (std::unique_ptr<pending_diagnostic> d,
+				    pending_location &&ploc)
 {
   LOG_FUNC (get_logger ());
-  auto curr_stmt_finder = custom_finder ? custom_finder : m_stmt_finder;
-  if (m_stmt == nullptr && curr_stmt_finder == nullptr)
-    {
-      if (get_logger ())
-	get_logger ()->log ("rejecting diagnostic: no stmt");
-      return false;
-    }
   if (m_eg)
     {
       bool terminate_path = d->terminate_path_p ();
-      pending_location ploc (m_enode_for_diag,
-			     m_enode_for_diag->get_supernode (),
-			     m_stmt,
-			     curr_stmt_finder);
-      if (m_eg->get_diagnostic_manager ().add_diagnostic (ploc,
+      if (m_eg->get_diagnostic_manager ().add_diagnostic (std::move (ploc),
 							  std::move (d)))
 	{
 	  if (m_path_ctxt
@@ -279,271 +267,6 @@ setjmp_svalue::get_enode_index () const
   return m_setjmp_record.m_enode->m_index;
 }
 
-/* Concrete implementation of sm_context, wiring it up to the rest of this
-   file.  */
-
-class impl_sm_context : public sm_context
-{
-public:
-  impl_sm_context (exploded_graph &eg,
-		   int sm_idx,
-		   const state_machine &sm,
-		   exploded_node *enode_for_diag,
-		   const program_state *old_state,
-		   program_state *new_state,
-		   const sm_state_map *old_smap,
-		   sm_state_map *new_smap,
-		   path_context *path_ctxt,
-		   const stmt_finder *stmt_finder = nullptr,
-		   bool unknown_side_effects = false)
-  : sm_context (sm_idx, sm),
-    m_logger (eg.get_logger ()),
-    m_eg (eg), m_enode_for_diag (enode_for_diag),
-    m_old_state (old_state), m_new_state (new_state),
-    m_old_smap (old_smap), m_new_smap (new_smap),
-    m_path_ctxt (path_ctxt),
-    m_stmt_finder (stmt_finder),
-    m_unknown_side_effects (unknown_side_effects)
-  {
-  }
-
-  logger *get_logger () const { return m_logger.get_logger (); }
-
-  tree get_fndecl_for_call (const gcall &call) final override
-  {
-    impl_region_model_context old_ctxt
-      (m_eg, m_enode_for_diag, nullptr, nullptr, nullptr/*m_enode->get_state ()*/,
-       nullptr, &call);
-    region_model *model = m_new_state->m_region_model;
-    return model->get_fndecl_for_call (call, &old_ctxt);
-  }
-
-  state_machine::state_t get_state (const gimple *stmt ATTRIBUTE_UNUSED,
-				    tree var) final override
-  {
-    logger * const logger = get_logger ();
-    LOG_FUNC (logger);
-    /* Use nullptr ctxt on this get_rvalue call to avoid triggering
-       uninitialized value warnings.  */
-    const svalue *var_old_sval
-      = m_old_state->m_region_model->get_rvalue (var, nullptr);
-
-    state_machine::state_t current
-      = m_old_smap->get_state (var_old_sval, m_eg.get_ext_state ());
-    return current;
-  }
-  state_machine::state_t get_state (const gimple *stmt ATTRIBUTE_UNUSED,
-				    const svalue *sval) final override
-  {
-    logger * const logger = get_logger ();
-    LOG_FUNC (logger);
-    state_machine::state_t current
-      = m_old_smap->get_state (sval, m_eg.get_ext_state ());
-    return current;
-  }
-
-
-  void set_next_state (const gimple *,
-		       tree var,
-		       state_machine::state_t to,
-		       tree origin) final override
-  {
-    logger * const logger = get_logger ();
-    LOG_FUNC (logger);
-    const svalue *var_new_sval
-      = m_new_state->m_region_model->get_rvalue (var, nullptr);
-    const svalue *origin_new_sval
-      = m_new_state->m_region_model->get_rvalue (origin, nullptr);
-
-    /* We use the new sval here to avoid issues with uninitialized values.  */
-    state_machine::state_t current
-      = m_old_smap->get_state (var_new_sval, m_eg.get_ext_state ());
-    if (logger)
-      logger->log ("%s: state transition of %qE: %s -> %s",
-		   m_sm.get_name (),
-		   var,
-		   current->get_name (),
-		   to->get_name ());
-    m_new_smap->set_state (m_new_state->m_region_model, var_new_sval,
-			   to, origin_new_sval, m_eg.get_ext_state ());
-  }
-
-  void set_next_state (const gimple *stmt,
-		       const svalue *sval,
-		       state_machine::state_t to,
-		       tree origin) final override
-  {
-    logger * const logger = get_logger ();
-    LOG_FUNC (logger);
-    impl_region_model_context old_ctxt
-      (m_eg, m_enode_for_diag, nullptr, nullptr, nullptr/*m_enode->get_state ()*/,
-       nullptr, stmt);
-
-    const svalue *origin_new_sval
-      = m_new_state->m_region_model->get_rvalue (origin, nullptr);
-
-    state_machine::state_t current
-      = m_old_smap->get_state (sval, m_eg.get_ext_state ());
-    if (logger)
-      {
-	logger->start_log_line ();
-	logger->log_partial ("%s: state transition of ",
-			     m_sm.get_name ());
-	sval->dump_to_pp (logger->get_printer (), true);
-	logger->log_partial (": %s -> %s",
-			     current->get_name (),
-			     to->get_name ());
-	logger->end_log_line ();
-      }
-    m_new_smap->set_state (m_new_state->m_region_model, sval,
-			   to, origin_new_sval, m_eg.get_ext_state ());
-  }
-
-  void warn (const supernode *snode, const gimple *stmt,
-	     tree var,
-	     std::unique_ptr<pending_diagnostic> d) final override
-  {
-    LOG_FUNC (get_logger ());
-    gcc_assert (d);
-    const svalue *var_old_sval
-      = m_old_state->m_region_model->get_rvalue (var, nullptr);
-    state_machine::state_t current
-      = (var
-	 ? m_old_smap->get_state (var_old_sval, m_eg.get_ext_state ())
-	 : m_old_smap->get_global_state ());
-    bool terminate_path = d->terminate_path_p ();
-    pending_location ploc (m_enode_for_diag, snode, stmt, m_stmt_finder);
-    m_eg.get_diagnostic_manager ().add_diagnostic
-      (&m_sm, ploc,
-       var, var_old_sval, current, std::move (d));
-    if (m_path_ctxt
-	&& terminate_path
-	&& flag_analyzer_suppress_followups)
-      m_path_ctxt->terminate_path ();
-  }
-
-  void warn (const supernode *snode, const gimple *stmt,
-	     const svalue *sval,
-	     std::unique_ptr<pending_diagnostic> d) final override
-  {
-    LOG_FUNC (get_logger ());
-    gcc_assert (d);
-    state_machine::state_t current
-      = (sval
-	 ? m_old_smap->get_state (sval, m_eg.get_ext_state ())
-	 : m_old_smap->get_global_state ());
-    bool terminate_path = d->terminate_path_p ();
-    pending_location ploc (m_enode_for_diag, snode, stmt, m_stmt_finder);
-    m_eg.get_diagnostic_manager ().add_diagnostic
-      (&m_sm, ploc,
-       NULL_TREE, sval, current, std::move (d));
-    if (m_path_ctxt
-	&& terminate_path
-	&& flag_analyzer_suppress_followups)
-      m_path_ctxt->terminate_path ();
-  }
-
-  /* Hook for picking more readable trees for SSA names of temporaries,
-     so that rather than e.g.
-       "double-free of '<unknown>'"
-     we can print:
-       "double-free of 'inbuf.data'".  */
-
-  tree get_diagnostic_tree (tree expr) final override
-  {
-    /* Only for SSA_NAMEs of temporaries; otherwise, return EXPR, as it's
-       likely to be the least surprising tree to report.  */
-    if (TREE_CODE (expr) != SSA_NAME)
-      return expr;
-    if (SSA_NAME_VAR (expr) != NULL)
-      return expr;
-
-    gcc_assert (m_new_state);
-    const svalue *sval = m_new_state->m_region_model->get_rvalue (expr, nullptr);
-    /* Find trees for all regions storing the value.  */
-    if (tree t = m_new_state->m_region_model->get_representative_tree (sval))
-      return t;
-    else
-      return expr;
-  }
-
-  tree get_diagnostic_tree (const svalue *sval) final override
-  {
-    return m_new_state->m_region_model->get_representative_tree (sval);
-  }
-
-  state_machine::state_t get_global_state () const final override
-  {
-    return m_old_state->m_checker_states[m_sm_idx]->get_global_state ();
-  }
-
-  void set_global_state (state_machine::state_t state) final override
-  {
-    m_new_state->m_checker_states[m_sm_idx]->set_global_state (state);
-  }
-
-  void clear_all_per_svalue_state () final override
-  {
-    m_new_state->m_checker_states[m_sm_idx]->clear_all_per_svalue_state ();
-  }
-
-  void on_custom_transition (custom_transition *transition) final override
-  {
-    transition->impl_transition (&m_eg,
-				 const_cast<exploded_node *> (m_enode_for_diag),
-				 m_sm_idx);
-  }
-
-  tree is_zero_assignment (const gimple *stmt) final override
-  {
-    const gassign *assign_stmt = dyn_cast <const gassign *> (stmt);
-    if (!assign_stmt)
-     return NULL_TREE;
-    impl_region_model_context old_ctxt
-      (m_eg, m_enode_for_diag, m_old_state, m_new_state, nullptr, nullptr, stmt);
-    if (const svalue *sval
-	= m_new_state->m_region_model->get_gassign_result (assign_stmt,
-							    &old_ctxt))
-      if (tree cst = sval->maybe_get_constant ())
-	if (::zerop(cst))
-	  return gimple_assign_lhs (assign_stmt);
-    return NULL_TREE;
-  }
-
-  path_context *get_path_context () const final override
-  {
-    return m_path_ctxt;
-  }
-
-  bool unknown_side_effects_p () const final override
-  {
-    return m_unknown_side_effects;
-  }
-
-  const program_state *get_old_program_state () const final override
-  {
-    return m_old_state;
-  }
-
-  const program_state *get_new_program_state () const final override
-  {
-    return m_new_state;
-  }
-
-  log_user m_logger;
-  exploded_graph &m_eg;
-  exploded_node *m_enode_for_diag;
-  const program_state *m_old_state;
-  program_state *m_new_state;
-  const sm_state_map *m_old_smap;
-  sm_state_map *m_new_smap;
-  path_context *m_path_ctxt;
-  const stmt_finder *m_stmt_finder;
-
-  /* Are we handling an external function with unknown side effects?  */
-  bool m_unknown_side_effects;
-};
-
 bool
 impl_region_model_context::
 get_state_map_by_name (const char *name,
@@ -579,104 +302,252 @@ get_state_map_by_name (const char *name,
 					     old_smap,
 					     new_smap,
 					     m_path_ctxt,
-					     m_stmt_finder,
 					     false);
     }
   return true;
 }
 
-/* Subclass of stmt_finder for finding the best stmt to report the leak at,
-   given the emission path.  */
+/* Subclass of pending_location::fixer_for_epath for finding the best stmt
+   to report the leak at, given the emission path.  */
 
-class leak_stmt_finder : public stmt_finder
+class leak_ploc_fixer_for_epath : public pending_location::fixer_for_epath
 {
 public:
-  leak_stmt_finder (const exploded_graph &eg, tree var)
-  : m_eg (eg), m_var (var) {}
-
-  std::unique_ptr<stmt_finder> clone () const final override
-  {
-    return std::make_unique<leak_stmt_finder> (m_eg, m_var);
-  }
+  leak_ploc_fixer_for_epath (const exploded_graph &eg, tree var)
+  : m_eg (eg), m_var (var)
+  {}
 
-  const gimple *find_stmt (const exploded_path &epath)
-    final override
+  void
+  fixup_for_epath (const exploded_path &epath,
+		   pending_location &ploc) const final override
   {
     logger * const logger = m_eg.get_logger ();
     LOG_FUNC (logger);
 
+    /* Handle the interprocedural case where we leak the retval at a return
+       because the caller discards the return value.  */
+    if (m_var
+	&& TREE_CODE (m_var) == RESULT_DECL)
+      {
+	auto &point = ploc.m_enode->get_point ();
+	if (point.get_stack_depth () > 1)
+	  if (point.get_supernode ()->exit_p ())
+	    {
+	      /* Get the program_point for the call within the caller.  */
+	      auto &cs = point.get_call_string ();
+	      auto caller_snode = cs.get_return_node_in_caller ();
+	      gcc_assert (caller_snode);
+	      program_point caller_point (caller_snode, *cs.get_parent ());
+	      ploc.m_event_loc_info = event_loc_info (caller_point);
+	      return;
+	    }
+      }
+
+    /* Handle the case where we have e.g.:
+       |   var = malloc (N);
+       |   var = NULL;
+       which with SSA becomes e.g.:
+       |   var_0 = malloc (N);
+       |   var_1 = nullptr;
+       and thus leads to the leak being found at the enode where "var_0" goes
+       out of scope.
+       Fix up the location of the leak to report it at the write of NULL.  */
     if (m_var && TREE_CODE (m_var) == SSA_NAME)
       {
+	log_scope sentinel (logger, "looking for write to sibling SSA name");
 	/* Locate the final write to this SSA name in the path.  */
 	const gimple *def_stmt = SSA_NAME_DEF_STMT (m_var);
 
 	int idx_of_def_stmt;
-	bool found = epath.find_stmt_backwards (def_stmt, &idx_of_def_stmt);
-	if (!found)
-	  goto not_found;
+	if (epath.find_stmt_backwards (def_stmt, &idx_of_def_stmt))
+	  {
+	    /* What was the next write to the underlying var
+	       after the SSA name was set? (if any).  */
 
-	/* What was the next write to the underlying var
-	   after the SSA name was set? (if any).  */
+	    for (unsigned idx = idx_of_def_stmt + 1;
+		 idx < epath.m_edges.length ();
+		 ++idx)
+	      {
+		const exploded_edge *eedge = epath.m_edges[idx];
+		if (logger)
+		  logger->log ("eedge[%i]: EN %i -> EN %i",
+			       idx,
+			       eedge->m_src->m_index,
+			       eedge->m_dest->m_index);
+		const gimple *stmt = eedge->maybe_get_stmt ();
+		if (!stmt)
+		  continue;
+		if (const gassign *assign = dyn_cast <const gassign *> (stmt))
+		  {
+		    tree lhs = gimple_assign_lhs (assign);
+		    if (TREE_CODE (lhs) == SSA_NAME
+			&& SSA_NAME_VAR (lhs) == SSA_NAME_VAR (m_var))
+		      {
+			if (logger)
+			  logger->log ("using location 0%lx from gassign",
+				       assign->location);
+			ploc.m_event_loc_info.m_loc = assign->location;
+			return;
+		      }
+		  }
+	      }
+	  }
+      }
 
-	for (unsigned idx = idx_of_def_stmt + 1;
-	     idx < epath.m_edges.length ();
-	     ++idx)
+    /* If the epath ends at a function exit node, the location is at
+       the final "}".  Try walking backward along EPATH, looking for a
+       the first suitable stmt with a better location.  */
+    gcc_assert (ploc.m_enode->get_supernode ());
+    const greturn *return_stmt = nullptr;
+    if (ploc.m_enode->get_supernode ()->exit_p ()
+	&& has_return_stmt_p (epath, return_stmt, logger))
+      {
+	/* If we have "return SSA_NAME;" on EPATH, keep track of the
+	   pertinent SSA name as we walk backwards through EPATH.  */
+	tree retval = NULL_TREE;
+	if (return_stmt)
+	  retval = gimple_return_retval (return_stmt);
+
+	log_scope sentinel (logger, "walking backward along epath");
+	int idx;
+	const exploded_edge *eedge;
+	FOR_EACH_VEC_ELT_REVERSE (epath.m_edges, idx, eedge)
 	  {
-	    const exploded_edge *eedge = epath.m_edges[idx];
 	    if (logger)
-	      logger->log ("eedge[%i]: EN %i -> EN %i",
-			   idx,
-			   eedge->m_src->m_index,
-			   eedge->m_dest->m_index);
-	    const exploded_node *dst_node = eedge->m_dest;
-	    const program_point &dst_point = dst_node->get_point ();
-	    const gimple *stmt = dst_point.get_stmt ();
-	    if (!stmt)
-	      continue;
-	    if (const gassign *assign = dyn_cast <const gassign *> (stmt))
 	      {
-		tree lhs = gimple_assign_lhs (assign);
-		if (TREE_CODE (lhs) == SSA_NAME
-		    && SSA_NAME_VAR (lhs) == SSA_NAME_VAR (m_var))
-		  return assign;
+		logger->log ("eedge[%i]: EN %i -> EN %i",
+			     idx,
+			     eedge->m_src->m_index,
+			     eedge->m_dest->m_index);
+		if (retval)
+		  logger->log ("  retval: %qE", retval);
+	      }
+	    if (auto op = eedge->maybe_get_op ())
+	      {
+		if (retval)
+		  if (auto phis = op->dyn_cast_phis_for_edge_op ())
+		    {
+		      for (auto iter : phis->get_pairs ())
+			if (retval == iter.m_dst)
+			  {
+			    /* We have "PHI(RETVAL = SRC);"
+			       Track SRC instead  */
+			    retval = iter.m_src;
+			    if (logger)
+			      logger->log ("updating retval to %qE", retval);
+			  }
+		    }
+		if (const gimple *stmt = op->maybe_get_stmt ())
+		  if (consider_stmt_location_p (*stmt, retval))
+		    if (useful_location_p (stmt->location))
+		      {
+			if (logger)
+			  logger->log ("using location 0x%lx from stmt",
+				       stmt->location);
+			ploc.m_event_loc_info.m_loc = stmt->location;
+			return;
+		      }
 	      }
 	  }
       }
+  }
 
-  not_found:
+private:
+  static bool
+  has_return_stmt_p (const exploded_path &epath,
+		     const greturn *&out_greturn,
+		     logger *logger)
+  {
+    LOG_SCOPE (logger);
 
-    /* Look backwards for the first statement with a location.  */
-    int i;
+    int idx;
     const exploded_edge *eedge;
-    FOR_EACH_VEC_ELT_REVERSE (epath.m_edges, i, eedge)
+    FOR_EACH_VEC_ELT_REVERSE (epath.m_edges, idx, eedge)
       {
-	if (logger)
-	  logger->log ("eedge[%i]: EN %i -> EN %i",
-		       i,
-		       eedge->m_src->m_index,
-		       eedge->m_dest->m_index);
-	const exploded_node *dst_node = eedge->m_dest;
-	const program_point &dst_point = dst_node->get_point ();
-	const gimple *stmt = dst_point.get_stmt ();
-	if (stmt)
-	  if (get_pure_location (stmt->location) != UNKNOWN_LOCATION)
-	    return stmt;
+	if (eedge->m_src->get_stack_depth ()
+	    != eedge->m_dest->get_stack_depth ())
+	  {
+	    /* We have interprocedural activity, and
+	       presumably are no longer in the function where
+	       EPATH terminates.
+	       Give up.  */
+	    return false;
+	  }
+	if (auto op = eedge->maybe_get_op ())
+	  {
+	    switch (op->get_kind ())
+	      {
+	      default:
+		break;
+	      case operation::kind::return_stmt:
+		if (logger)
+		  logger->log ("found return_stmt");
+		out_greturn = &((const greturn_op *)op)->get_greturn ();
+		return true;
+	      case operation::kind::predict_stmt:
+		{
+		  auto &stmt = ((const gimple_stmt_op *)op)->get_stmt ();
+		  switch (gimple_predict_predictor (&stmt))
+		    {
+		    case PRED_TREE_EARLY_RETURN:
+		      /* Assume this is due to a "return;" in the user's
+			 code.  */
+		      if (logger)
+			logger->log ("assuming a return: PRED_TREE_EARLY_RETURN");
+		      return true;
+		    default:
+		      break;
+		    }
+		}
+		break;
+	      }
+	  }
       }
-
-    gcc_unreachable ();
-    return nullptr;
+    return false;
   }
 
-  void update_event_loc_info (event_loc_info &) final override
+  /* When certain statements show up on the epath of a leak
+     at an exit node, if they have locations, these locations
+     tend to be better locations for the leak.
+     Return true for such statements (but without checking their
+     locations).  */
+  static bool
+  consider_stmt_location_p (const gimple &stmt,
+			    tree retval)
   {
-    /* No-op.  */
+    if (retval && TREE_CODE (retval) == SSA_NAME)
+      if (&stmt == SSA_NAME_DEF_STMT (retval))
+	return true;
+
+    switch (stmt.code)
+      {
+      default:
+	break;
+      case GIMPLE_CALL:
+	{
+	  const gcall &call = *as_a <const gcall *> (&stmt);
+	  if (is_cxa_end_catch_p (call))
+	    return true;
+	}
+	break;
+      case GIMPLE_PREDICT:
+      case GIMPLE_RETURN:
+	return true;
+      }
+    return false;
   }
 
-private:
   const exploded_graph &m_eg;
   tree m_var;
 };
 
+std::unique_ptr<pending_location::fixer_for_epath>
+make_ploc_fixer_for_epath_for_leak_diagnostic (const exploded_graph &eg,
+					  tree var)
+{
+  return std::make_unique<leak_ploc_fixer_for_epath> (eg, var);
+}
+
 /* A measurement of how good EXPR is for presenting to the user, so
    that e.g. we can say prefer printing
      "leak of 'tmp.m_ptr'"
@@ -831,13 +702,16 @@ returning_from_function_p (const supernode *snode)
   const supernode *iter = snode;
   while (true)
     {
-      if (iter->return_p ())
+      if (iter->exit_p ())
 	return true;
       if (iter->m_succs.length () != 1)
 	return false;
       const superedge *sedge = iter->m_succs[0];
-      if (sedge->get_kind () != SUPEREDGE_CFG_EDGE)
-	return false;
+
+      if (auto op = sedge->get_op ())
+	if (op->get_kind () == operation::kind::return_stmt)
+	  return true;
+
       iter = sedge->m_dest;
 
       /* Impose a limit to ensure we terminate for pathological cases.
@@ -851,7 +725,7 @@ returning_from_function_p (const supernode *snode)
 	   return _val;
 
 	   EXIT BB.*/
-      if (++count > 3)
+      if (++count > 4)
 	return false;
     }
 }
@@ -907,7 +781,6 @@ impl_region_model_context::on_state_leak (const state_machine &sm,
 	logger->log ("best leaked_tree: NULL");
     }
 
-  leak_stmt_finder stmt_finder (*m_eg, leaked_tree);
   gcc_assert (m_enode_for_diag);
 
   /* Don't complain about leaks when returning from "main".  */
@@ -928,12 +801,11 @@ impl_region_model_context::on_state_leak (const state_machine &sm,
 						       m_new_state);
   if (pd)
     {
-      pending_location ploc (m_enode_for_diag,
-			     m_enode_for_diag->get_supernode (),
-			     m_stmt,
-			     &stmt_finder);
+      pending_location ploc (get_pending_location_for_diag ());
+      ploc.m_fixer_for_epath
+	= std::make_unique<leak_ploc_fixer_for_epath> (*m_eg, leaked_tree);
       m_eg->get_diagnostic_manager ().add_diagnostic
-	(&sm, ploc,
+	(&sm, std::move (ploc),
 	 leaked_tree_for_diag, sval, state, std::move (pd));
     }
 }
@@ -957,12 +829,7 @@ impl_region_model_context::on_condition (const svalue *lhs,
 			       m_old_state->m_checker_states[sm_idx],
 			       m_new_state->m_checker_states[sm_idx],
 			       m_path_ctxt);
-      sm.on_condition (sm_ctxt,
-		       (m_enode_for_diag
-			? m_enode_for_diag->get_supernode ()
-			: nullptr),
-		       m_stmt,
-		       lhs, op, rhs);
+      sm.on_condition (sm_ctxt, lhs, op, rhs);
     }
 }
 
@@ -984,11 +851,7 @@ impl_region_model_context::on_bounded_ranges (const svalue &sval,
 			       m_old_state->m_checker_states[sm_idx],
 			       m_new_state->m_checker_states[sm_idx],
 			       m_path_ctxt);
-      sm.on_bounded_ranges (sm_ctxt,
-			    (m_enode_for_diag
-			     ? m_enode_for_diag->get_supernode ()
-			     : nullptr),
-			    m_stmt, sval, ranges);
+      sm.on_bounded_ranges (sm_ctxt, sval, ranges);
     }
 }
 
@@ -1025,7 +888,7 @@ impl_region_model_context::on_phi (const gphi *phi, tree rhs)
 			       m_old_state->m_checker_states[sm_idx],
 			       m_new_state->m_checker_states[sm_idx],
 			       m_path_ctxt);
-      sm.on_phi (sm_ctxt, m_enode_for_diag->get_supernode (), phi, rhs);
+      sm.on_phi (sm_ctxt, phi, rhs);
     }
 }
 
@@ -1059,6 +922,15 @@ impl_region_model_context::maybe_did_work ()
     *m_out_could_have_done_work = true;
 }
 
+pending_location
+impl_region_model_context::get_pending_location_for_diag () const
+{
+  if (m_stmt && useful_location_p (m_stmt->location))
+    return pending_location (m_enode_for_diag, m_stmt->location);
+  else
+    return pending_location (m_enode_for_diag);
+}
+
 /* struct point_and_state.  */
 
 /* Assert that this object is sane.  */
@@ -1198,6 +1070,7 @@ exploded_node::status_to_str (enum status s)
     default: gcc_unreachable ();
     case status::worklist: return "worklist";
     case status::processed: return "processed";
+    case status::special: return "special";
     case status::merger: return "merger";
     case status::bulk_merged: return "bulk_merged";
     }
@@ -1213,23 +1086,6 @@ exploded_node::exploded_node (const point_and_state &ps,
   gcc_checking_assert (ps.get_state ().m_region_model->canonicalized_p ());
 }
 
-/* Get the stmt that was processed in this enode at index IDX.
-   IDX is an index within the stmts processed at this enode, rather
-   than within those of the supernode.  */
-
-const gimple *
-exploded_node::get_processed_stmt (unsigned idx) const
-{
-  gcc_assert (idx < m_num_processed_stmts);
-  const program_point &point = get_point ();
-  gcc_assert (point.get_kind () == PK_BEFORE_STMT);
-  const supernode *snode = get_supernode ();
-  const unsigned int point_stmt_idx = point.get_stmt_idx ();
-  const unsigned int idx_within_snode = point_stmt_idx + idx;
-  const gimple *stmt = snode->m_stmts[idx_within_snode];
-  return stmt;
-}
-
 /* For use by dump_dot, get a value for the .dot "fillcolor" attribute.
    Colorize by sm-state, to make it easier to see how sm-state propagates
    through the exploded_graph.  */
@@ -1297,12 +1153,21 @@ exploded_node::dump_dot (graphviz_out *gv, const dump_args_t &args) const
       m_ps.get_point ().print (pp, f);
       pp_newline (pp);
 
-      const extrinsic_state &ext_state = args.m_eg.get_ext_state ();
-      const program_state &state = m_ps.get_state ();
-      state.dump_to_pp (ext_state, false, true, pp);
-      pp_newline (pp);
+      bool show_state = true;
+
+      /* Don't show the state if we have a single predecessor
+	 and the state hasn't changed.  */
+      if (m_preds.length () == 1
+	  && get_state () == m_preds[0]->m_src->get_state ())
+	show_state = false;
 
-      dump_processed_stmts (pp);
+      if (show_state)
+	{
+	  const extrinsic_state &ext_state = args.m_eg.get_ext_state ();
+	  const program_state &state = m_ps.get_state ();
+	  state.dump_to_pp (ext_state, false, true, pp);
+	  pp_newline (pp);
+	}
     }
 
   dump_saved_diagnostics (pp);
@@ -1336,31 +1201,6 @@ exploded_node::dump_dot (graphviz_out *gv, const dump_args_t &args) const
   pp_flush (pp);
 }
 
-/* Show any stmts that were processed within this enode,
-   and their index within the supernode.  */
-void
-exploded_node::dump_processed_stmts (pretty_printer *pp) const
-{
-  if (m_num_processed_stmts > 0)
-    {
-      const program_point &point = get_point ();
-      gcc_assert (point.get_kind () == PK_BEFORE_STMT);
-      const supernode *snode = get_supernode ();
-      const unsigned int point_stmt_idx = point.get_stmt_idx ();
-
-      pp_printf (pp, "stmts: %i", m_num_processed_stmts);
-      pp_newline (pp);
-      for (unsigned i = 0; i < m_num_processed_stmts; i++)
-	{
-	  const unsigned int idx_within_snode = point_stmt_idx + i;
-	  const gimple *stmt = snode->m_stmts[idx_within_snode];
-	  pp_printf (pp, "  %i: ", idx_within_snode);
-	  pp_gimple_stmt_1 (pp, stmt, 0, (dump_flags_t)0);
-	  pp_newline (pp);
-	}
-    }
-}
-
 /* Dump any saved_diagnostics at this enode to PP.  */
 
 void
